// Copyright PingCAP, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/pingcap/tidb-operator/pkg/apis/pingcap/v1alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// TidbClusterLister helps list TidbClusters.
type TidbClusterLister interface {
	// List lists all TidbClusters in the indexer.
	List(selector labels.Selector) (ret []*v1alpha1.TidbCluster, err error)
	// TidbClusters returns an object that can list and get TidbClusters.
	TidbClusters(namespace string) TidbClusterNamespaceLister
	TidbClusterListerExpansion
}

// tidbClusterLister implements the TidbClusterLister interface.
type tidbClusterLister struct {
	indexer cache.Indexer
}

// NewTidbClusterLister returns a new TidbClusterLister.
func NewTidbClusterLister(indexer cache.Indexer) TidbClusterLister {
	return &tidbClusterLister{indexer: indexer}
}

// List lists all TidbClusters in the indexer.
func (s *tidbClusterLister) List(selector labels.Selector) (ret []*v1alpha1.TidbCluster, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.TidbCluster))
	})
	return ret, err
}

// TidbClusters returns an object that can list and get TidbClusters.
func (s *tidbClusterLister) TidbClusters(namespace string) TidbClusterNamespaceLister {
	return tidbClusterNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// TidbClusterNamespaceLister helps list and get TidbClusters.
type TidbClusterNamespaceLister interface {
	// List lists all TidbClusters in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1alpha1.TidbCluster, err error)
	// Get retrieves the TidbCluster from the indexer for a given namespace and name.
	Get(name string) (*v1alpha1.TidbCluster, error)
	TidbClusterNamespaceListerExpansion
}

// tidbClusterNamespaceLister implements the TidbClusterNamespaceLister
// interface.
type tidbClusterNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all TidbClusters in the indexer for a given namespace.
func (s tidbClusterNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.TidbCluster, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.TidbCluster))
	})
	return ret, err
}

// Get retrieves the TidbCluster from the indexer for a given namespace and name.
func (s tidbClusterNamespaceLister) Get(name string) (*v1alpha1.TidbCluster, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("tidbcluster"), name)
	}
	return obj.(*v1alpha1.TidbCluster), nil
}
